#include <stdio.h>

int weight[1010];
double time[1010];

double maximumCasu(int a, int b)
{
    int min, max, i;
    double maximum;

    min = (a < b) ? a : b;
    max = (a < b) ? b : a;
    maximum = time[min];
    for (i = min+1; i <= max; i++) {
	maximum = (maximum > time[i]) ? maximum : time[i];
    }
    return(maximum);
}

void bridge(int load, int length, int cars)
{
    int i, j;
    struct {
        int weight;
        double time;
    } table[1010];
    double opts[1010];

    for (i = 0; i < cars; i++) {
	int speed;
	scanf("%d %d", &weight[i], &speed);
	time[i] = length * 60.0 / (double) speed;
	opts[i] = time[i] + ((i > 0) ? opts[i-1] : 0);
    }

    for (i = 0; i < cars; i++) {
        for (j = i; j >= 0; j--) {
	    table[j].weight = weight[i] + ((i > 0) ? table[j].weight : 0);
	    if (table[j].weight > load) break;
	    table[j].time = maximumCasu(i, j);
	    if (j > 0 && i > 0) table[j].time += opts[j-1];
	    opts[i] = (opts[i] <= table[j].time) ? opts[i] : table[j].time;
/*	    printf(" [%d,%d](%d %g)", i, j,
	           table[j].weight, table[j].time); */
	}
/*	printf(" opt: %.2f\n", opts[i]); */
    }
    printf("%.1f\n", opts[cars-1]);
}

int main(void)
{
    int load, length, cars;
    
    do {
	scanf("%d %d %d", &load, &length, &cars);
	if (load == 0 && length == 0 && cars == 0) break;
	bridge(load, length, cars);
    } while (1);
    return(0);
}
